<template>
    <div class="box w-full flex justify-center items-center">
        <div class="w-full">
            <h2 class="text-xl text-center font-bold p-4 m-2">About User</h2>
            <hr class="border-gray-300" />
             <!-- Profile Page -->
      <div class="flex flex-col md:flex-row gap-10 md:gap-0 px-3 py-10">
        <!-- Profile Picture and Basic Info -->
        <div class="flex-1 text-center md:text-left">
          <div class="flex flex-col items-center md:items-start">
            <div class="w-56 h-56 relative">
              <img class="rounded-full border-gray-600 w-full h-full object-cover" :class="{ 'border': !user.profile_picture }" :src="user.profile_picture ? user.profile_picture.src : `/user.jpeg`">
              <button type="button" @click="dialog.showModal()"
                                class="absolute right-1 bottom-7 rounded-full h-10 w-10 flex justify-center items-center bg-black hover:bg-gray">
                                <Icon icon="fa-solid fa-gear" class="text-2xl text-white"></Icon>
                            </button>
            </div>
            <p class="mt-3"><strong>{{ user.name }}</strong></p>
            <p>{{ user.role.name }}</p>
          </div>
        </div>

        <!-- Detailed Info -->
        <div class="flex-1 flex flex-col md:block items-center md:items-start">
          <div class="space-y-10 w-full">
            <!-- Basic Info Section -->
            <div class="text-base">
              <h3 class="mb-2 text-xl text-gray-500">
                <Icon icon="fa-solid fa-user" class="mr-2" />Basic Info
              </h3>
              <p>Name: {{ user.name }}</p>
              <p>CID: {{ user.cid }}</p>
              <p>Email: {{ user.email }}</p>
            </div>

            <!-- Job Info Section -->
            <div class="text-base">
              <h3 class="mb-2 text-xl text-gray-500">
                <Icon icon="fa-solid fa-briefcase" class="mr-2" />Job
              </h3>
              <p>DOJ: {{ user.doj }}</p>
            </div>

            <!-- Roles Section -->
            <div class="text-base">
              <h3 class="mb-2 text-xl text-gray-500">
                <Icon icon="fa-solid fa-street-view" class="mr-2" />Roles
              </h3>
              <p>Role type: {{ user.role.name }}</p>
              <p v-if="user.department">Department Head For: {{ user.department.name }}</p>
              <p v-if="user.department_staff_detail">Department: {{ user.department_staff_detail?.department.name }}</p>
              <p v-if="user.department_staff_detail">Designation: {{ user.department_staff_detail?.designation }}</p>
            </div>
          </div>
        </div>
      </div>
        </div>
    </div>

    <!-- Dialog -->
   <dialog id="dialog" ref="dialog" class="box p-5 w-full md:w-[600px] rounded-md shadow-lg">
    <form @submit.prevent="form.post('/profile/changeProfilePicture')">
      <div class="font-semibold text-gray-700 text-lg flex items-center">
        <i class="fa-solid fa-edit mr-2"></i>
        <label>Edit Profile Picture</label>
      </div>
      <hr class="my-4 border-gray-200">

      <div class="flex justify-center">
        <div>
          <img
            class="block rounded-full border-gray-600 w-40 h-40 md:w-60 md:h-60 object-cover"
            :class="{ 'border': !user.profile_picture }"
            :src="user.profile_picture ? user.profile_picture.src : '/user.jpeg'"
            alt="Current Profile Picture"
          >
        </div>
      </div>

      <div class="mt-6">
        <div class="flex items-center mb-4">
          <input type="checkbox" id="delete_picture" class="checkbox" :disabled="!user.profile_picture" v-model="form.delete_picture">
          <label for="delete_picture" class="text-sm ml-2" :class="{ 'opacity-50': !user.profile_picture }">Delete current picture</label>
        </div>

        <div class="mb-4 text-sm font-semibold">
          <label for="pfpInput">Pick a picture</label>
          <input ref="pfpInput" id="pfpInput" type="file" @change="(event) => form.profile_picture = event.target.files[0]" class="block w-full mt-2 text-sm file:mr-4 file:py-2 file:px-4 file:rounded-full file:border-0 file:text-sm file:bg-blue-50 file:text-blue-700 hover:file:bg-blue-100" accept="image/*">
        </div>
        
        <div v-if="form.errors.profile_picture" class="text-red-500 text-sm">
          {{ form.errors.profile_picture }}
        </div>
      </div>

      <div class="flex justify-end gap-3 mt-6">
      <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
  
        <button type="button" @click="dialog.close()" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">
          Cancel
        </button>

      </div>
    </form>
  </dialog>
</template>

<script setup>
import { ref, watch } from 'vue';
import { useForm, usePage } from '@inertiajs/vue3';

defineProps({
    user: Object
});

const dialog = ref(null);
const pfpInput = ref(null);
const form = useForm({
    delete_picture: false,
    profile_picture: null,
});

const page = usePage();

watch(page, (value) => {
    if (value.props.flash.success) {
        document.getElementById('dialog').close();
        form.delete_picture = false
        document.getElementById('pfpInput').value = '';
        form.profile_picture = null
    }
});
</script>
